#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sha1.h"

int main(int argc, char **argv)
{

	printf("My Pokemon Ranch Hash Updater v0.1 by suloku\n");
    printf("------------------------------------------\n");
	printf("\tBuilt: " __TIME__ " " __DATE__ "\n");
	printf("\tCopyright 2014 suloku>\n"
			"\tLicensed under the terms of the GNU GPL, version 2\n"
			"\thttp://www.gnu.org/licenses/old-licenses/gpl-2.0.txt\n"
			"\tUses smallsha1: https://code.google.com/p/smallsha1\n\n");


    FILE *file;
    unsigned long fileLen;
    char * buffer;

	//Open file
	file = fopen(argv[1], "rb");
	if (!file)
	{
		printf("Unable to open %s\n\tPress enter to exit.", argv[1]);
		getchar();
		return 0;
	}
	//Get file length
	fseek(file, 0, SEEK_END);
	fileLen=ftell(file);
	fileLen = fileLen -20;
	fseek(file, 20, SEEK_SET); //skip hash

    // allocate memory to contain the whole file:
    buffer = (char*) malloc (sizeof(char)*fileLen);
    if (buffer == NULL) {printf ("Memory error\nPress enter to exit."); getchar(); return -1;}

    fread(buffer, fileLen, 1, file);
    fclose(file);

    // The data to be hashed
    unsigned char hash[20];

    sha1::calc(buffer, fileLen, hash);
    // hash now contains the 20-byte SHA-1 hash

    fopen("savedata_hashed.bin", "wb");
        fwrite (hash , 1, 20, file); //write new hash
        fwrite (buffer , 1, fileLen, file); //write contents
    fclose(file);
    if (buffer != NULL) free(buffer);

/*
    char test[41];
    sha1::toHexString(hash, test);
    printf("%s %d\n", test, fileLen);
*/
    printf("%s SHA-1 hash is now valid.\n", argv[1]);
    printf("\nPress enter to exit.\n");
    getchar();

    return 0;
}
