#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

#ifdef _WIN32
    #include <direct.h>
    #include <windows.h>
    #include <locale.h>
    typedef unsigned char uint8_t;
    typedef unsigned short uint16_t;
    typedef unsigned int uint32_t;
    #define mkdir(a, b) _mkdir(a)
    #define chdir _chdir
#else
    #include <unistd.h>
    #include <stdint.h>
    #include <sys/stat.h>
#endif

#define be16(x) ((((x)>>8)&0xFF)|((((x)<<8))&0xFF00))
#define be32(x) (((x)<<24)|(((x)>>8)&0xFF00)|(((x)<<8)&0xFF0000)|((x)>>24))

#define mem_free(x) {if (x != NULL){free(x);x=NULL;}}

//convert hexstring to len bytes of data
//returns 0 on success, -1 on error
//data is a buffer of at least len bytes
//hexstring is upper or lower case hexadecimal, NOT prepended with "0x"
int hex2data(unsigned char *data, const unsigned char *hexstring, unsigned int len)
{
    unsigned const char *pos = hexstring;
    char *endptr;
    size_t count = 0;

    if ((hexstring[0] == '\0') || (strlen(hexstring) % 2)) {
        //hexstring contains no data
        //or hexstring has an odd length
        return -1;
    }

    for(count = 0; count < len; count++) {
        char buf[5] = {'0', 'x', pos[0], pos[1], 0};
        data[count] = strtol(buf, &endptr, 0);
        pos += 2 * sizeof(char);

        if (endptr[0] != '\0') {
            //non-hexadecimal character encountered
            return -1;
        }
    }

    return 0;
}

int main(int argc, char **argv)
{

	printf("My Pokemon Ranch ID changer v0.2 by suloku\n");
    printf("------------------------------------------\n");
	printf("\tBuilt: " __TIME__ " " __DATE__ "\n");
	printf("\tCopyright 2014 suloku>\n"
			"\tLicensed under the terms of the GNU GPL, version 2\n"
			"\thttp://www.gnu.org/licenses/old-licenses/gpl-2.0.txt\n\n\n");

	FILE *file, *tnrfile;
	char pokemon[136];
    unsigned long fileLen;
    char * buffer;

    FILE *pokefile;
    int pokecount = 1;
    uint8_t poke_type;// 01 trainer, 04 hayley, 05 traded
    uint16_t unknown1;
    uint8_t tradeable;// 02 is tradeable, normal 00
    uint16_t tid;
    uint16_t sid;
    uint32_t name1;
    uint32_t name2;
    uint32_t name3;
    uint32_t name4;
    uint32_t unknown2;

    //unsigned char newtrainer[20]= {0xF5, 0xB8, 0x75, 0xD7, 0x3D, 0x01, 0x59, 0x01, 0x50, 0x01, 0x53, 0x01, 0x4f, 0x01, 0x59, 0x01, 0xff, 0xff, 0x00, 0x00};
    unsigned char finalTID[2];
    unsigned char finalSID[2];
    unsigned char finalname[16];
	//Open file
	file = fopen("savedata.bin", "rb");
	if (!file)
	{
		printf("Unable to open savedata.bin\n\tPress enter to exit.");
		getchar();
		return 0;
	}

	pokefile = fopen("savedata_new.bin", "wb");
	if (!file)
	{
		printf("Unable to open savedata_new.bin\n\tPress enter to exit.");
		getchar();
		return 0;
	}

	//Get file length
	fseek(file, 0, SEEK_END);
	fileLen=ftell(file);
	fseek(file, 0, SEEK_SET);
    // allocate memory to contain the whole file:
    buffer = (char*) malloc (sizeof(char)*fileLen);
    if (buffer == NULL) {printf ("Memory error\nPress enter to exit."); getchar(); return -1;}

	fseek(file, 0x22AC, SEEK_SET);
    uint32_t miientries;
    fread(&miientries, 4, 1, file);
	//printf ("Miientries %x\n", be32(miientries));
	printf ("There are %4d Miis registered.\n", be32(miientries));

	fseek(file, 0x22AC+(40*be32(miientries))+4+4, SEEK_SET);
    uint32_t miilinkentries;
    fread(&miilinkentries, 4, 1, file);
	//printf ("Miientries %x\n", be32(miilinkentries));
	printf ("There are %4d trainers with stored pokemon.\n", be32(miilinkentries));

	fseek(file, 0x22AC+(40*be32(miientries))+4+4+(44*be32(miilinkentries))+4+4, SEEK_SET);
    uint32_t pokemonentries;
    fread(&pokemonentries, 4, 1, file);
	//printf ("Miientries %x\n", be32(pokemonentries));
	printf ("There are %4d pokemon stored (includes Hayley's pokemon).\n\n", be32(pokemonentries));

//Open .tnr file if specified
    tnrfile = fopen(argv[1], "rb");
	if (!tnrfile)
	{
        printf("\nUnable to open %s trainer file. Press enter to manually input the data.\n", argv[1]);
        getchar();

        printf ("\nPlease, enter the TID, SID and Name in HEX values (case insensitive), here's an example:\n");
        printf ("\tTID: 47349 --> HEX: F5B8\n");
        printf ("\tSID: 55157 --> HEX: 75D7\n");
        printf ("\tName: Suloku --> HEX: 3D015901500153014F015901FFFF0000\n\n");
        printf("Enter TID:\n");
        char newTID[4];
        gets(newTID);
        if (strlen (newTID) != 4){
            printf("The input is too long/short. Exiting...");
            getchar();
            return 0;
        }
        if (hex2data(finalTID, newTID, 2) != 0){
            printf("Wrong input. Exiting...");
            getchar();
            return 0;
        }
        printf("Enter SID:\n");
        char newSID[4];
        gets(newSID);
        if (strlen (newSID) != 4){
            printf("The input is too long/short. Exiting...");
            getchar();
            return 0;
        }
        if (hex2data(finalSID, newSID, 2) != 0){
            printf("Wrong input. Exiting...");
            getchar();
            return 0;
        }
        printf("Enter Name:\n");
        char newNAME[32];
        gets(newNAME);
        if (strlen (newNAME) != 32){
            printf("The input is too long/short. Exiting...");
            getchar();
            return 0;
        }
        if (hex2data(finalname, newNAME, 16) != 0){
            printf("Wrong input. Exiting...");
            getchar();
            return 0;
        }

	}else{
        fread(finalTID, 2, 1, tnrfile);
        fread(finalSID, 2, 1, tnrfile);
        fread(finalname, 16, 1, tnrfile);
	}
	fclose(tnrfile);

    printf ("\tNew trainer information:\n");
    printf ("\t\tTID  HEX: %02X%02X\n", finalTID[0], finalTID[1]);
    printf ("\t\tSID  HEX: %02X%02X\n", finalSID[0], finalSID[1]);
    printf ("\t\tName HEX: ");
    int j= 0;
    for (j=0;j<16;j++){
        printf("%02X",finalname[j]);
    }

	//write this part of the file
	//Actually, the checksum at the header should be updated after editing the savegame file,
	//it seems to be at the header of the file, but I don't know how to do it.
    fseek(file, 0, SEEK_SET);
    fread(buffer, (0x22AC+(40*be32(miientries))+4+4+(44*be32(miilinkentries))+4+4+4), 1, file);

    //show current trainer in ranch
    int s;
    for(s=0;s<be32(miilinkentries);s++){
        printf ("\n\n\tRanch trainer #%d information:\n", s+1);
        printf ("\t\tTID  HEX: %02X%02X\n", (uint8_t)buffer[0x22AC+(40*be32(miientries))+4+4+4+12+(44*s)], (uint8_t)buffer[0x22AC+(40*be32(miientries))+4+4+4+12+(44*s)+1]);
        printf ("\t\tSID  HEX: %02X%02X\n", (uint8_t)buffer[0x22AC+(40*be32(miientries))+4+4+4+12+(44*s)+2], (uint8_t)buffer[0x22AC+(40*be32(miientries))+4+4+4+12+(44*s)+3]);
        printf ("\t\tName HEX: ");
        for (j=0;j<16;j++){
            printf("%02X",(uint8_t)buffer[0x22AC+(40*be32(miientries))+4+4+4+12+(44*s)+4+j]);
        }

    }

	//If the game detects two miis with the same associated TID, SID and name the game will freeze.
	//We could parse and compare the entries, but asking the user is easier
	int trainerpresent = 0;
	while(1){
        printf ("\n\nHas this trainer connected to this ranch? (y/n):\n");
        char inputbuff[32];
        gets(inputbuff);
        if (!strcmp (inputbuff, "y")){
            printf("\nOk. If Pokemon Ranch freezes when loading the savegame it means that the trainer didn't connect to the ranch. Please run again and select no.\n");
            trainerpresent = 1;
            break;
        }else if (!strcmp (inputbuff, "n")){
            printf("\nOk. If Pokemon Ranch freezes when loading the savegame it means that the trainer did connect to the ranch. Please run again and select yes.\n");
            printf("\nAdding trainer to the list of trainers with pokemon in the ranch.\n");
            trainerpresent = 0;
            break;
        }
        printf("Wrong input. Please type only 'y' or 'n'.\n");
	}

    if (!trainerpresent){
        //Change first mii-trainer entry to specified trainer
        memcpy(buffer+0x22AC+(40*be32(miientries))+4+4+4+12, finalTID, 2);
        memcpy(buffer+0x22AC+(40*be32(miientries))+4+4+4+12+2, finalSID, 2);
        memcpy(buffer+0x22AC+(40*be32(miientries))+4+4+4+12+4, finalname, 16);
    }
    fwrite (buffer , 1, (0x22AC+(40*be32(miientries))+4+4+(44*be32(miilinkentries))+4+4+4), pokefile);


	printf("\n\n\tChanging all pokemon to your trainer...");

	int i;
	for (i=0;i<be32(pokemonentries);i++)
	{
        fread(pokemon, 136, 1, file);
        fread(&poke_type, 1, 1, file);
        fread(&unknown1, 2, 1, file);
        fread(&tradeable, 1, 1, file);
        fread(&tid, 2, 1, file);
        fread(&sid, 2, 1, file);
        fread(&name1, 4, 1, file);
        fread(&name2, 4, 1, file);
        fread(&name3, 4, 1, file);
        fread(&name4, 4, 1, file);
        fread(&unknown2, 4, 1, file);

        //write the .pkm file
        fwrite (pokemon , sizeof(char), sizeof(pokemon), pokefile);

        if (poke_type == 0x04){
            //Don't change hayley's pokemon
            //Ranch info
            fwrite (&poke_type , sizeof(char), sizeof(poke_type), pokefile);
            fwrite (&unknown1 , sizeof(char), sizeof(unknown1), pokefile);
            fwrite (&tradeable , sizeof(char), sizeof(tradeable), pokefile);
            //Write TID, SID and trainer name
            fwrite (&tid , sizeof(char), sizeof(tid), pokefile);
            fwrite (&sid , sizeof(char), sizeof(sid), pokefile);
            fwrite (&name1 , sizeof(char), sizeof(name1), pokefile);
            fwrite (&name2 , sizeof(char), sizeof(name2), pokefile);
            fwrite (&name3 , sizeof(char), sizeof(name3), pokefile);
            fwrite (&name4 , sizeof(char), sizeof(name4), pokefile);
            //Writte unknown2
            fwrite (&unknown2 , sizeof(char), sizeof(unknown2), pokefile);
        }else if (poke_type == 0x05){
            //Don't change hayley's pokemon
            //Ranch info
            fwrite (&poke_type , sizeof(char), sizeof(poke_type), pokefile);
            fwrite (&unknown1 , sizeof(char), sizeof(unknown1), pokefile);
            fwrite (&tradeable , sizeof(char), sizeof(tradeable), pokefile);
            //Write TID, SID and trainer name
            fwrite (&tid , sizeof(char), sizeof(tid), pokefile);
            fwrite (&sid , sizeof(char), sizeof(sid), pokefile);
            fwrite (&name1 , sizeof(char), sizeof(name1), pokefile);
            fwrite (&name2 , sizeof(char), sizeof(name2), pokefile);
            fwrite (&name3 , sizeof(char), sizeof(name3), pokefile);
            fwrite (&name4 , sizeof(char), sizeof(name4), pokefile);
            //Writte unknown2
            fwrite (&unknown2 , sizeof(char), sizeof(unknown2), pokefile);
        }else{
            //Ranch info
            fwrite (&poke_type , sizeof(char), sizeof(poke_type), pokefile);
            fwrite (&unknown1 , sizeof(char), sizeof(unknown1), pokefile);
            fwrite (&tradeable , sizeof(char), sizeof(tradeable), pokefile);
            //Write TID, SID and trainer name
            //fwrite (newtrainer , sizeof(char), 20, pokefile);
            fwrite (finalTID , sizeof(char), 2, pokefile);
            fwrite (finalSID , sizeof(char), 2, pokefile);
            fwrite (finalname , sizeof(char), 16, pokefile);
            //Writte unknown2
            fwrite (&unknown2 , sizeof(char), sizeof(unknown2), pokefile);
        }
        pokecount++;
    }

    long remaining = fileLen - ftell(file);

	//write the end of the file
    fread(buffer, remaining, 1, file);
    fwrite (buffer , sizeof(char), remaining , pokefile);

    fclose (pokefile);
	fclose(file);

	//To do: reopen savedata_new.bin and update the header checksum
	/*
        pokefile = fopen("savedata_new.bin", "wb");
        if (!file)
        {
            printf("Unable to open savedata_new.bin\n\tPress enter to exit.");
            getchar();
            return 0;
        }

        //Do the checksum magic

        fclose (pokefile);
	*/

    printf("done!\n");
    printf("\nPress enter to exit.");
    getchar();


    return 0;
}
