#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sha1.h"

int main(int argc, char **argv)
{

	printf("My Pokemon Ranch Region Changer v0.1 by suloku\n");
    printf("------------------------------------------\n");
	printf("\tBuilt: " __TIME__ " " __DATE__ "\n");
	printf("\tCopyright 2014 suloku>\n"
			"\tLicensed under the terms of the GNU GPL, version 2\n"
			"\thttp://www.gnu.org/licenses/old-licenses/gpl-2.0.txt\n"
			"\tUses smallsha1: https://code.google.com/p/smallsha1\n\n");


    FILE *file;
    unsigned long fileLen;
    char * buffer;

	//Open file
	file = fopen(argv[1], "rb");
	if (!file)
	{
		printf("Unable to open %s\n\tPress enter to exit.", argv[1]);
		getchar();
		return 0;
	}
	//Get file length
	fseek(file, 0, SEEK_END);
	fileLen=ftell(file);
	fileLen = fileLen -20;
	fseek(file, 20, SEEK_SET); //skip hash

    // allocate memory to contain the whole file:
    buffer = (char*) malloc (sizeof(char)*fileLen);
    if (buffer == NULL) {printf ("Memory error\nPress enter to exit."); getchar(); return -1;}

    fread(buffer, fileLen, 1, file);
    fclose(file);

    char lang;

        printf("\nPlease input new region.\n");
        printf("\n\n"
               "\tNTSC-J | NTSC-U (alternative) [0x00] - j\n"
               "\tNTSC-U        [0x02] - u\n"
               "\tPAL - English [0x08] - e\n"
               "\tPAL - Dutch   [0x08] - d\n"
               "\tPAL - German  [0x10] - g\n"
               "\tPAL - French  [0x18] - f\n"
               "\tPAL - Spanish [0x20] - s\n"
               "\tPAL - Italian [0x28] - i\n\n");

        printf("Enter region (only one letter, lower case):\n");
        char newregion[256];
        gets(newregion);
        if (strlen (newregion) != 1){
            printf("The input is too long/short. Exiting...");
            getchar();
            return 0;
        }
        switch(*newregion){
            case 'j'  :
               lang = 0x00;
               break;
            case 'u'  :
               lang = 0x02;
               break;
            case 'e'  :
               lang = 0x08;
               break;
            case 'd'  :
               lang = 0x08;
               break;
            case 'g'  :
               lang = 0x10;
               break;
            case 'f'  :
               lang = 0x18;
               break;
            case 's'  :
               lang = 0x20;
               break;
            case 'i'  :
               lang = 0x28;
               break;

            default :
                printf("\nInvalid input. Press enter to exit.\n");
                getchar();
                return 0;
                break;
        }

    //Update region
    buffer[0x53-0x14] = lang;

    // The data to be hashed
    unsigned char hash[20];
    sha1::calc(buffer, fileLen, hash);
    // hash now contains the 20-byte SHA-1 hash

    char newfile[128];
    sprintf(newfile, "savedata_%s_hashed.bin", newregion);

    fopen(newfile, "wb");
        fwrite (hash , 1, 20, file); //write new hash
        fwrite (buffer , 1, fileLen, file); //write contents
    fclose(file);
    if (buffer != NULL) free(buffer);

/*
    char test[41];
    sha1::toHexString(hash, test);
    printf("%s %d\n", test, fileLen);
*/
    printf("\nRegion succesfully changed.\n%s SHA-1 hash is now valid.\n", argv[1]);
    printf("\nPress enter to exit.\n");
    getchar();

    return 0;
}
